> For the complete documentation index, see [llms.txt](https://doc.batch.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.batch.com/developer/sdk/web/profile-data/email-subscription.md).

# Email subscription

Since v4 of the Batch Web SDK, you can:

* Add and remove email address from a user profile. The profile will automatically be created if needed.
* Edit a profile's marketing subscription.

{% hint style="info" %}
In order to set an email address and subscription status on a profile, the [creation of a project](https://doc.batch.com/getting-started/other/overview-guides/98-send-emails-with-batch#create-a-project) is required. If no project is set up, any calls made for these actions will be ignored.
{% endhint %}

Here is how to set an email with a marketing subscription:

{% tabs %}
{% tab title="JavaScript (ES8)" %}

```javascript
batchSDK(async api => {
    const profile = await api.profile();
    // This requires to have a custom user ID registered 
    await profile.identify({customId: "custom_user_id"});
    await profile.edit(editor => {
      editor
        .setEmailAddress("john.doe@batch.com") // Null to erase. Addresses must be valid.
        .setEmailMarketingSubscription("subscribed") // Or "unsubscribed"
    })
});
```

{% endtab %}

{% tab title="JavaScript" %}

```javascript
batchSDK(api => {
    api.profile().then(profile => {
      profile.identify({customId: "custom_user_id"}).then(profile => {
        profile.edit(editor => {
          editor
            .setEmailAddress("john.doe@batch.com") // Null to erase. Addresses must be valid.
            .setEmailMarketingSubscription("subscribed") // Or "unsubscribed"
        })
      })
    })
});
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://doc.batch.com/developer/sdk/web/profile-data/email-subscription.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
